<html>
<head>
<meta charset="UTF-8" />
<meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta name="viewport" content="width=device-width, initial-scale=1">


<title>DES - Data Encryption Standard - Decryption</title>
<script type="text/javascript" src="http://code.jquery.com/jquery-1.10.2.js"></script>


<script type="text/javascript" src="scripts/fabric.min.js"></script>
<script type="text/javascript" src="scripts/BinaryArray.js"></script>
<script type="text/javascript" src="scripts/fabric.ext.js"></script>
<script type="text/javascript" src="scripts/crypto.des.js"></script>


<style type="text/css">
	input[type=text] {
		font-family: Consolas;
	}
</style>


</head>
<body>

<table>
	<tr>  
		<td>Cipher Text</td> 
		<td> <input id='txtCipherText' type='text' value='0BE257BCDCB0FB52' /> </td>  
		<td>
			<select id="cmbCipherType">
				<option value="binary">Binary</option>
				<option value="hex" selected>Hex</option>
				<option value="base64">Base 64</option>
			</select>
		</td>
	</tr>
	<tr>  
		<td>Key</td> 
		<td> <input id='txtKeyText' type='text' value='0000000000000000' /> </td> 
		<td>
			<select id="cmbKeyType">
				<option value="utf8">UTF-8</option>
				<option value="ascii">ASCII</option>
				<option value="hex" selected>Hex</option>
				<option value="binary">Binary</option>
				<option value="base64">Base 64</option>
			</select>
		</td>
	</tr>
	<tr>  
		<td>Plain Text</td> 
		<td> <input id='txtPlainText' type='text' value='' /> </td>   
		<td>
			<select id="cmbPlainType">
				<option value="utf8">UTF-8</option>
				<option value="ascii">ASCII</option>
				<option value="hex" selected>Hex</option>
				<option value="binary">Binary</option>
				<option value="base64">Base 64</option>
			</select>
		</td>
	</tr>
	<tr>  <td></td> <td> <input type="checkbox" id="chkFunctions"> Fonksiyonları göster. </td>  </tr>

	<tr>  
		<td>Round Count</td> 
		<td> <input id='txtRoundCount' type='text' value='16' /> </td>  
		<td> </td>
	</tr>

	<tr>  <td> <button id="rect">Hesapla</button> </td>   </tr>
</table>

<canvas id="c" width="2500" height="12000" style="border: solid 1px"></canvas>

<script type="text/javascript">




function toSub(value) {
	var str = "";

	//  Get the number of digits, with a minimum at 0 in case the value itself is 0
	var mag = Math.max(0, Math.floor(Math.log10(value)));
	
	//  Loop through all digits
	while (mag >= 0)
	{
		//  Current digit's value
		var digit = Math.floor(value/Math.pow(10, mag))%10;
		
		//  Append as subscript character
		str += String.fromCharCode(8320 + digit);
		mag--;
	}
	return str;
}



var lineoptions = { strokeWidth: 1, stroke: 'black', hasBorders: false, hasControls: false, lockMovementX: true, lockMovementY: true, };



var ffunction = function(level, left, top, width, height, ri, ki, printScreen) {

	var rib = BinaryArray(ri.data);
	var kib = BinaryArray(ki.data);

	var exp = rib.permutate(DES_CONSTANTS.E);
	var xor = exp.xor(kib);
	var parts = xor.split(6);
	var sout = parts.map((a,i) => BinaryArray(DES_CONSTANTS.SBOX[i][a.toInt()].toString(2).padStart(4, '0')));
	var sout2 = BinaryArray(sout.reduce((x,y) => x + y.text, ''));
	var perm = sout2.permutate(DES_CONSTANTS.P);


	var fleft = left;
	var ftop  =  top;

	if (printScreen) 
	{
		var blockRi = new fabric.Block({ top: ftop, left: fleft, width: width, height: height, 
			name: "R" + toSub(level), 
			data: rib,
		});
		canvas.add(blockRi);

		var blockFE = new fabric.Block({ top: blockRi.bottom + 30, left: fleft - width * 0.2, width: width*1.4, height: height, 
			name: "Expansion - E", 
			data: exp, 
		});
		canvas.add(blockFE);
		
		var xorF = new fabric.XorGate({ radius: 20, top: blockFE.bottom + 30, left: blockFE.center - 20, });
		canvas.add(xorF);

		var blockKi = new fabric.Block({ top: xorF.middle - height/2 , left: xorF.left - width*1.4 - 50, width: width*1.4, height: height, 
			name: pc2.name, // "K" + toSub(16-level-1), 
			data: kib, 
		});
		canvas.add(blockKi);

		
		canvas.add(new fabric.LineArrow([blockRi.center, blockRi.bottom, blockFE.center, blockFE.top], lineoptions));
		canvas.add(new fabric.LineArrow([blockFE.center, blockFE.bottom, xorF.center, xorF.top], lineoptions));
		canvas.add(new fabric.LineArrow([blockKi.right, blockKi.middle, xorF.left, xorF.middle], lineoptions));


		var blockAra = new fabric.Block({ top: xorF.bottom + 30, left: blockFE.left, width: width*1.4, height: height*0.7, 
			name: " ", 
			data: xor, 
		});
		canvas.add(blockAra);
		canvas.add(new fabric.LineArrow([xorF.center, xorF.bottom, blockAra.center, blockAra.top], lineoptions));


		var blockAra2 = new fabric.Block({ top: blockAra.bottom + 100 + height, left: blockFE.left, width: width*1.4, height: height*0.7, 
			name: " ", 
			data: sout2, 
		});
		canvas.add(blockAra2);
		

		var count = 8;
		var swidth = width*0.2
		var space =25;
		var sleft = blockAra.center - (swidth * count + space * (count - 1))/2;
		var stop = blockAra.bottom + 60;

		for (var i =0 ; i < count; i++){
			var si = new fabric.FBlock({ top: stop, left: sleft + (swidth + space) * i, width: swidth, height: height*0.6,  name: "S" + toSub(i+1),  data:'101011', });
			canvas.add(si);

			canvas.add(new fabric.Text(parts[i].text,  { 
				left: si.center - 50, 
				top: blockAra.bottom + 40, 
				fontSize: 12, 
				fontFamily: 'Courier New',
				hasBorders: false, hasControls: false, lockMovementX: true, lockMovementY: true,
			}));

			canvas.add(new fabric.Text(sout[i].text,  { 
				left: si.center - 35, 
				top: si.bottom + 5, 
				fontSize: 12, 
				fontFamily: 'Courier New',
				hasBorders: false, hasControls: false, lockMovementX: true, lockMovementY: true,
			}));

			canvas.add(
				new fabric.Line([blockAra.center, blockAra.bottom, blockAra.center, blockAra.bottom + 30], lineoptions),
				new fabric.Line([blockAra.center, blockAra.bottom + 30, si.center, blockAra.bottom + 30], lineoptions),
				new fabric.LineArrow([si.center, blockAra.bottom + 30, si.center, si.top], lineoptions),
			);

			canvas.add(
				new fabric.Line([si.center, si.bottom, si.center, si.bottom + 30], lineoptions),
				new fabric.Line([si.center, si.bottom + 30, blockAra2.center, si.bottom + 30], lineoptions),
				new fabric.LineArrow([blockAra2.center, si.bottom + 30, blockAra2.center, blockAra2.top], lineoptions),
			);
		}
		
		var blockFP2 = new fabric.Block({ top: blockAra2.bottom + 30, left: blockFE.left, width: width*1.4, height: height, 
			name: "Permutation - P", 
			data: perm, 
		});
		canvas.add(blockFP2);
		canvas.add(new fabric.LineArrow([blockAra2.center, blockAra2.bottom, blockFP2.center, blockFP2.top], lineoptions));
	}
	else
	{
		var blockFP2 = new fabric.Block({ top: 0, left: 0, width: width*1.4, height: height, 
			name: "Permutation - P", 
			data: perm, 
		});
	}
	return blockFP2;
}

// pc2, ci, di
var keytransform = function(level, top, ci, di, width, height) {

	var shift = DES_CONSTANTS.OneShift.indexOf(level)>=0 ? 1 : 2;
	if (level == 1) shift = 0;

	var ls1l = BinaryArray(ci.data).rotateRight(shift);
	var ls1r = BinaryArray(di.data).rotateRight(shift); 
	var pc2  = ls1l.merge(ls1r).permutate(DES_CONSTANTS.PC2);

	var left = ci.left;

	var blockLS1_1 = new fabric.Block({ top: top, left: left, width: width*0.85, height: height, 
		name: "RS" + toSub(level) + " (" + shift + ")", 
		data: ls1l, 
	});
	var blockLS1_2 = new fabric.Block({ top: top, left: blockLS1_1.right, width: width*0.85, height: height, 
		name: "RS" + toSub(level) + " (" + shift + ")", 
		data: ls1r, 
	});
	canvas.add(blockLS1_1);
	canvas.add(blockLS1_2);


	var blockC1 = new fabric.Block({ top: blockLS1_1.bottom + 45, left: ci.left, width: width*0.85, height: height, 
		name: "C" + toSub(16 - level), 
		data: ls1l, 
	});
	var blockD1 = new fabric.Block({ top: blockLS1_1.bottom + 45, left: blockC1.right, width: width*0.85, height: height, 
		name: "D" + toSub(16 - level), 
		data: ls1r, 
	});
	canvas.add(blockC1);
	canvas.add(blockD1);
	

	var blockPC2 = new fabric.Block({ top: blockC1.top, left: left - width*1.4 - 50, width: width*1.4, height: height, 
		name: "K"+ toSub(16 - level) + "  (PC-2)", 
		data: pc2, 
	});
	canvas.add(blockPC2);

	

	
	canvas.add(new fabric.LineArrow([blockC1.left, blockC1.middle, blockPC2.right, blockPC2.middle], lineoptions));

	canvas.add(new fabric.LineArrow([blockLS1_1.center, blockLS1_1.bottom, blockC1.center, blockC1.top], lineoptions));
	canvas.add(new fabric.LineArrow([blockLS1_2.center, blockLS1_2.bottom, blockD1.center, blockD1.top], lineoptions));


	var tranform1 = new fabric.Rect({ left: blockPC2.left - 20, top: blockLS1_1.top - 20, width: 940, height: 205, 
		fill: 'transparent', 
		stroke: 'black', 
		strokeDashArray: [5, 5],
		strokeWidth: 1, 
		hasBorders: false, 
		hasControls: false, 
		lockMovementX: true, 
		lockMovementY: true, 
	})
	canvas.add(tranform1);


	console.log(level, blockPC2.hex);

	canvas.add(new fabric.LineArrow([ci.center, ci.bottom, blockLS1_1.center, blockLS1_1.top], lineoptions));
	canvas.add(new fabric.LineArrow([di.center, di.bottom, blockLS1_2.center, blockLS1_2.top], lineoptions));	
	return [blockPC2, blockC1, blockD1];


}

var level = function(level, ip, left, top, width, height) {

	var ip = BinaryArray(ip.data);	
	var li = ip.firstHalf();
	var ri = ip.secondHalf();

	var blockLi = new fabric.Block({ top: top, left: left, width: width, height: height, 
		name: "L" + toSub(level), 
		data: li,
	});
	var blockRi = new fabric.Block({ top: top, left: blockLi.right, width: width, height: height, 
		name: "R" + toSub(level), 
		data: ri, 
	});
	canvas.add(blockLi);
	canvas.add(blockRi);

	return [blockLi, blockRi];
}

var level2 = function(level, lo, ro, ki, ffunc, left, top, width, height) {
	
	var li = BinaryArray(lo.data);
	var ri = BinaryArray(ro.data);
	var f = BinaryArray(ffunc.data);
	

	var xor1 = new fabric.XorGate({ radius: 20, top:  lo.bottom + 90, left: lo.center - 20, });
	canvas.add(xor1);
	canvas.add(new fabric.LineArrow([lo.center, lo.bottom, xor1.center, xor1.top], lineoptions));

	var fblock = new fabric.Block({ left: ro.left - 80, top: xor1.middle - height/2, width: width, height: height, 
		name: "f", 
		data: ffunc.data, 
	})
	canvas.add(fblock);
	

	canvas.add(
		new fabric.Line([ro.center + 90, ro.bottom, ro.center + 90, fblock.middle], lineoptions),
		new fabric.LineArrow([ro.center + 90, fblock.middle, fblock.right, fblock.middle], lineoptions)
	);
	
	canvas.add(new fabric.LineArrow([fblock.left, fblock.middle, xor1.right, xor1.middle], lineoptions));

	canvas.add(
		new fabric.Line([ki.left, ki.middle, fblock.center, ki.middle], lineoptions),
		new fabric.LineArrow([fblock.center, ki.middle, fblock.center, fblock.top], lineoptions)
	);


	var xorvalue = li.xor(f);

	var blockLi = new fabric.Block({ top: top, left: left, width: width, height: height, 
		name: "L" + toSub(level), 
		data: ri,
	});
	var blockRi = new fabric.Block({ top: top, left: blockLi.right, width: width, height: height, 
		name: "R" + toSub(level), 
		data: xorvalue, 
	});
	canvas.add(blockLi);
	canvas.add(blockRi);


	var center1 = (blockLi.top - fblock.bottom) / 3;
	var center2 = center1 * 2;


	canvas.add(
		new fabric.Line([ro.center + 90, fblock.middle, ro.center + 90, fblock.middle + center1], lineoptions),
		new fabric.Line([ro.center + 90, fblock.middle + center1, blockLi.center, fblock.bottom + center2], lineoptions),
		new fabric.LineArrow([blockLi.center, fblock.bottom + center2, blockLi.center, blockLi.top], lineoptions));

	canvas.add(
		new fabric.Line([lo.center, xor1.bottom, lo.center, xor1.bottom + center1], lineoptions),
		new fabric.Line([lo.center, xor1.bottom + center1, blockRi.center, fblock.bottom + center2], lineoptions),
		new fabric.LineArrow([blockRi.center, fblock.bottom + center2, blockRi.center, blockRi.top], lineoptions));


	return [blockLi, blockRi];
}


var canvas = new fabric.Canvas('c');
$("#rect").on("click", function(e) {



	var ciphertext = $('#txtCipherText').val();
	var key = $('#txtKeyText').val();


	var cipherType = $("#cmbCipherType").val();
	var keyType = $("#cmbKeyType").val();
	var plainType = $("#cmbPlainType").val();


	var ciphertextBitArray = BinaryArray(ciphertext, cipherType);
	var keyBitArray = BinaryArray(key, keyType);


	var writeScreen = $("#chkFunctions").prop("checked");

	var roundCount = parseInt($("#txtRoundCount").val());


	var ip = ciphertextBitArray.permutate(DES_CONSTANTS.IPf);


	

	var width = 240;
	var height = 55;
	var left = writeScreen ? 650 : 30;


	canvas.clear();

	// -------------  Plain Text  ----------------

	var blockX = new fabric.Block({ top: 60, left: left + width*0.05, width: width*1.9, height: height, 
		name: "Plaintext - x", 
		data: ciphertextBitArray, 
	});
	canvas.add(blockX);


	var blockIP = new fabric.Block({ top: blockX.bottom + 30, left: left + width*0.05, width: width*1.9, height: height, 
		name: "Initial Permutation - IP", 
		data: ip, 
	});
	canvas.add(blockIP);

	
	canvas.add(new fabric.LineArrow([blockX.center, blockX.bottom, blockIP.center, blockIP.top], lineoptions));
	
	// -------------  Plain Text  ----------------



	// -------------  Key  ----------------

	var pc1 = keyBitArray.permutate(DES_CONSTANTS.PC1);
	var ci = pc1.firstHalf();
	var di = pc1.secondHalf();

	var blockK = new fabric.Block({ top: 60, left: left + 890, width: width*1.8, height: height, 
		name: "Key - k", 
		data: keyBitArray, 
	});
	canvas.add(blockK);

	var blockPC1 = new fabric.Block({ top: blockK.bottom+30, left: blockK.left + width*0.05, width: width*1.7, height: height, 
		name: "PC-1", 
		data: pc1, 
	});
	canvas.add(blockPC1);

	//canvas.add(new fabric.LineArrow([blockK.center, blockK.bottom, blockLS1_1.right, blockLS1_1.top], lineoptions));

	var blockC0 = new fabric.Block({ top: blockPC1.bottom + 30, left: blockPC1.left, width: width*0.85, height: height, 
		name: "C" + toSub('16'), 
		data: ci, 
	});
	var blockD0 = new fabric.Block({ top: blockC0.top, left: blockC0.right, width: width*0.85, height: height, 
		name: "D" + toSub('16'), 
		data: di, 
	});
	canvas.add(blockC0);
	canvas.add(blockD0);

	canvas.add(new fabric.LineArrow([blockK.center, blockK.bottom, blockPC1.center, blockPC1.top], lineoptions));
	canvas.add(new fabric.LineArrow([blockPC1.center, blockPC1.bottom, blockC0.right, blockC0.top], lineoptions));

	// -------------  Key  ----------------

	var top = blockC0.bottom + 70;




	var [li, ri] = level(0, blockIP, left, top, width, height);
	
	canvas.add(new fabric.LineArrow([blockIP.center, blockIP.bottom, li.right, li.top], lineoptions));


	var ci = blockC0;
	var di = blockD0;

	var space = writeScreen ? 650 : 310;

	for (var i = 0; i < roundCount; i++) {

		var t = top + i * space;

		canvas.add(new fabric.Line([0, t-55, 2500, t-55], { 
			strokeWidth: 1, 
			stroke: 'black', 
			hasBorders: false, 
			hasControls: false, 
			lockMovementX: true, 
			lockMovementY: true, 
			strokeDashArray: [5, 5], 
			color: 'red',
			stroke: 'red', 
		}));

		[pc2, ci, di] = keytransform(i+1, t, ci, di, width, height);

		var fout  = ffunction(i, 300, t, width, height, ri, pc2, writeScreen);

		[li, ri] = level2(i+1, li, ri, pc2, fout, left, t+space, width, height);

	}
	

	canvas.add(new fabric.Line([0, li.top-55, 2500, li.top-55], { 
		strokeWidth: 1, 
		stroke: 'black', 
		hasBorders: false, 
		hasControls: false, 
		lockMovementX: true, 
		lockMovementY: true, 
		strokeDashArray: [5, 5], 
		color: 'red',
		stroke: 'red',
	}));


	var ld = BinaryArray(li.data);
	var rd = BinaryArray(ri.data);
	var merge = rd.merge(ld);
	var perm = merge.permutate(DES_CONSTANTS.IPr)


	var blockAra = new fabric.Block({ top: li.bottom + 100, left: left + width*0.05, width: width*1.9, height: height*0.7, 
		name: " ", 
		data: merge, 
	});
	canvas.add(blockAra);
	//canvas.add(new fabric.LineArrow([li.right, li.bottom, blockAra.center, blockAra.top], lineoptions));
	canvas.add(
		new fabric.Line([li.center, li.bottom, li.center, li.bottom+30], lineoptions),
		new fabric.Line([li.center, li.bottom+30, ri.center, li.bottom+70], lineoptions),
		new fabric.LineArrow([ri.center, li.bottom+70, ri.center, blockAra.top], lineoptions),
	);

	canvas.add(
		new fabric.Line([ri.center, ri.bottom, ri.center, ri.bottom+30], lineoptions),
		new fabric.Line([ri.center, ri.bottom+30, li.center, ri.bottom+70], lineoptions),
		new fabric.LineArrow([li.center, ri.bottom+70, li.center, blockAra.top], lineoptions),
	);



	var blockIPR = new fabric.Block({ top: blockAra.bottom + 100, left: left + width*0.05, width: width*1.9, height: height, 
		name: "Final Permutation - IP^-1", 
		data: perm, 
	});
	canvas.add(blockIPR);
	canvas.add(new fabric.LineArrow([blockAra.center, blockAra.bottom, blockIPR.center, blockIPR.top], lineoptions));


	$('#txtPlainText').val(blockIPR.data.toString(plainType));

});
$("#rect2").on("click", function(e) {

	

});

$("#rect").click();
</script>

</body>
</html>